'''
@author: Telecoda
'''

ANIMATION_LOOP = 1
ANIMATION_RUNONCE =2

class GameObject(object):
    '''
    Base class for all game objects
    '''


    def __init__(self):
        '''
        Constructor
        '''
        self.isDestructible = False
        self.isSolid = False
        self.isExploding = False
 
        self.visible = True
        self.animStartFrame=0
        self.animEndFrame=0
        self.animCurrentFrame=0
        self.animFrameTick=0
        self.animCurrentTick=0
        self.animRunning=False
        self.animStyle=ANIMATION_LOOP
        self.grid_x=0
        self.grid_y=0
        self.screen_x=0
        self.screen_y=0

        self.images = {}

    def animation_tick(self):
        if(self.animRunning):
            # increment tick counter
            self.animCurrentTick += 1
            if(self.animCurrentTick == self.animFrameTick):
                # if number of ticks reached increment frame counter
                self.animCurrentTick = 0
                # increment frame counter
                self.animCurrentFrame += 1
                # check if end

                
                if(self.animCurrentFrame == self.animEndFrame):
                    # if run once stop
                    if(self.animStyle == ANIMATION_RUNONCE):
                        self.animRunning = False
                        self.animCurrentFrame=self.animEndFrame
                    else:
                        # start again
                        self.animCurrentFrame=self.animStartFrame
                    # do any action for end of animation here
                    self.executeEndOfAnimationMethod()

        
    def draw (self):
        '''
        draws game object on current screen
        '''
        if(not self.visible):
            return
        
    def execute_end_of_anim_meth(self):
        '''
        dynamically call a method at the end of an animation
        '''
        if(self.end_of_anim_meth == None):
            return
        self.self.end_of_anim_meth(self)
        

    def setImage(self, image):
        self.images[0] = image
    def setImages(self, images):
        self.images = images

       
    def setScreenLocation(self, sx,sy):
        self.sx = sx
        self.sy = sy


    def set_end_of_anim_meth(self, method):
        '''
        set method to call at end of animation
        '''
        self.self.end_of_anim_meth = method



